unit uCiaComportE;

interface

uses
  Classes,
  {$ifdef VER210}
    // Delphi 14 (2010)
    DesignIntf, DesignEditors,
  {$ELSE}
  {$ifdef VER200}
    // Delphi 12 (2009)
    DesignIntf, DesignEditors,
  {$ELSE}
  {$ifdef VER180}
    // Delphi 10 (2006)
    DesignIntf, DesignEditors,
  {$ELSE}
  {$ifdef VER170}
    // Delphi 9 (2005)
    DesignIntf, DesignEditors,
  {$ELSE}
  {$IFDEF VER150}
    // Delphi 7
    // Added DesignIde.dcp to the package requires section.
    DesignIntf, DesignEditors,
  {$ELSE}
  {$IFDEF VER140}
    // Delphi 6
    // Added DesignIde.dcp to the package requires section.
    DesignIntf, DesignEditors,
  {$ELSE}
    // Delphi 5: Add $(DELPHI)\Source\ToolsAPI to your library path, or copy
    // DsgnIntf.pas to a search path, for example 'Lib'
    DsgnIntf,
   {$ENDIF}
{$ENDIF}
{$ENDIF}
{$ENDIF}
{$ENDIF}
{$ENDIF}
  SysUtils;

type
  TCiaComPortLineEndProperty = class(TStringProperty)
  public
    function  GetLineEnd(const Value: string): string;
    function  SetLineEnd(const Value: string): string;
    function  GetValue: string; override;
    procedure SetValue(const Value: string); override;
  end;

procedure Register;

implementation

uses
   uCiaComPort;

procedure Register;
begin
   RegisterComponents('Cia', [TCiaComPort]);
   RegisterPropertyEditor(TypeInfo(string), TCiaComport, 'LineEnd', TCiaComPortLineEndProperty);
end;

//------------------------------------------------------------------------------
//---- property editor ---------------------------------------------------------
//------------------------------------------------------------------------------
function TCiaComPortLineEndProperty.SetLineEnd(const Value: string): string;
var
   Offset: integer;
   c: char;
begin
   if Pos('#', Value) = 0 then
      raise ECiaComPort.Create('Invalid value');

   Offset := 1;
   Result := '';
   repeat
      if Value[Offset] <> '#' then
         break;
      Inc(Offset);

      c := #0;
      while (Offset <= Length(Value)) and (Value[Offset] in ['0'..'9'])do begin
         c := Char(Ord(c) * 10 + Ord(Value[Offset]) - Ord('0'));
         Inc(Offset);
      end;

      Result := Result + c;
   until Offset > Length(Value);
end;

//------------------------------------------------------------------------------
function TCiaComPortLineEndProperty.GetLineEnd(const Value: string): string;
var
   n: integer;
begin
   Result := '';
   for n := 1 to Length(Value) do
      Result := Result + '#' + IntToStr(Ord(Value[n]));
end;

//------------------------------------------------------------------------------
function TCiaComPortLineEndProperty.GetValue: string;
begin
  Result := GetLineEnd(inherited GetValue);
end;

//------------------------------------------------------------------------------
procedure TCiaComPortLineEndProperty.SetValue(const Value: string);
begin
  inherited SetValue(SetLineEnd(Value));
end;

end.
